<template>
  <div class="max-w-[1200px] m-auto pb-[100px] text-center pt-[20px]">
      <CustomSelect class="mb-[100px]" placeholder="Выберите опцию" filterable v-model="selectedTitle" :options="options" :getSearchString="opt => `${opt.title} ${opt.uniqueIdentifier}`" />
      <CustomSelect class="mb-[100px]" placeholder="Выберите опцию" filterable :getOptionLabel="opt => opt?.name" :getOptionValue="opt => opt?.value" v-model="selectedName" :options="otherOptions" :getSearchString="opt => `${opt.value} ${opt.name}`"/>
      <CustomSelect class="mb-[100px]" placeholder="Выберите опцию" filterable :getOptionLabel="opt => opt?.data.name" :getOptionValue="opt => opt?.id" v-model="selectedCity" :options="cities" :getSearchString="opt => `${opt.data.code} ${opt.data.name}`">
      <template v-slot:options="{filteredOption,isOptionSelected,getOptionValue,selectOption,getOptionLabel}">
        <h3
          v-for="option in filteredOption"
          :class="{'italic font-bold': isOptionSelected(option)}"
          :key="getOptionValue(option)"
          @click="selectOption(option)"
          class="cursor-pointer text-left ml-[20px] mt-[15px] mb-[15px]"
          >{{getOptionLabel(option)}}
        </h3>
      </template>
      </CustomSelect>
      <CustomSelect placeholder="Multi Select" filterable multiple :getOptionLabel="opt => opt.name"  :getOptionValue="opt => opt.value" v-model="selectedThings" :options="otherOptions" :getSearchString="opt => `${opt.value} ${opt.name}`" />
      <CustomCheckBox class="mt-[30px]" v-model="selectedCheckBox" />
      <div class="flex justify-center mt-[50px] text-left">
        <ul>
          <li v-for="post in allPosts" :key="post.id"><span class="font-bold">Post #{{post.id}}</span>: {{post.title}}</li>
        </ul>
      </div>
      <CustomPagination @update-pagination="loadPosts" :totalCount="totalCount" :perPage="perPage" :currentPage="currentPage"/>
      <div class="mt-[30px]">
        <div v-for="faq in faqs" :key="faq.id">
          <h2 class="bg-accordion text-[#444] cursor-pointer p-[18px] w-full border-none text-left outline-none text-[15px] transition-all duration-500 flex justify-between rounded-t-[10px] hover:bg-accordion-hover" @click="faq.open = !faq.open">{{faq.question}}<img v-if="!faq.open" alt="▼" class="w-[18px]" src="../assets/select-icons/select-icon-open.svg" /><img v-else alt="▼" class="w-[18px]" src="../assets/select-icons/select-icon-close.svg" /></h2>
          <CustomAccordion :isOpened="faq.open">{{faq.answer}}</CustomAccordion>
        </div>
      </div>
  </div>
  <router-view></router-view>
</template>

<script setup>
import CustomSelect from '../components/CustomSelect.vue'
import CustomCheckBox from '../components/CustomCheckBox.vue'
import CustomPagination from '../components/CustomPagination.vue'
import CustomAccordion from '../components/CustomAccordion.vue'
import { onMounted, readonly, ref } from 'vue'

const selectedTitle = ref(null)
const selectedName = ref(null)
const selectedCity = ref(null)
const selectedThings = ref([])
const selectedCheckBox = ref(false)

const totalCount = ref(null)
const perPage = ref(10)
const currentPage = ref(1)

const options = readonly([
  { uniqueIdentifier: 1, title: 'To clean sth' },
  { uniqueIdentifier: 2, title: 'To help mom' },
  { uniqueIdentifier: 3, title: 'To do homework' }
])
const otherOptions = [
  { name: 'Serhii', value: 'uuiav44j2' },
  { name: 'Andrew', value: 'jjazoqk2h' },
  { name: 'Jane', value: 'na2pz169z' }
]
const cities = [
  { id: 1, data: { name: 'Ukraine', code: 'UK' } },
  { id: 2, data: { name: 'United States', code: 'USA' } },
  { id: 3, data: { name: 'Belgium', code: 'BE' } }
]

const faqs = ref([
  {
    id: 1,
    question: 'Who are you?',
    answer: 'I am a man',
    open: false
  },
  {
    id: 2,
    question: 'Are you a super hero?',
    answer: 'Lorem ipsum dolor sit amet consectetur adipisicing elit. Maiores quas asperiores, expedita quam vel pariatur, aliquid qui ipsam hic dignissimos perferendis, blanditiis deleniti optio deserunt. Aut optio illum enim consectetur.',
    open: false
  },
  {
    id: 3,
    question: 'How to contact you?',
    answer: 'Lorem ipsum dolor sit amet consectetur adipisicing elit. Maiores quas asperiores, expedita quam vel pariatur, aliquid qui ipsam hic dignissimos perferendis, blanditiis deleniti optio deserunt. Aut optio illum enim consectetur.',
    open: false
  }
])

const loadPosts = (page) => {
  currentPage.value = page
  getPosts()
}
const allPosts = ref([])

const getPosts = async () => {
  await fetch(`https://jsonplaceholder.typicode.com/photos?_page=${currentPage.value}&_limit=${perPage.value}`)
    .then((data) => data.json())
    .then(res => {
      allPosts.value = res
    })

  const length = await fetch('https://jsonplaceholder.typicode.com/photos').then(data => data.json()).then(res => res.length)
  totalCount.value = length
}

onMounted(() => {
  getPosts()
})

</script>
